# Class WrappedPlainView

java.lang.Object
javax.swing.text.View
javax.swing.text.CompositeView
javax.swing.text.BoxView
javax.swing.text.WrappedPlainView

All Implemented Interfaces:
  `SwingConstants, TabExpander`

public class WrappedPlainView extends BoxView implements TabExpander
View of plain text (text with only one font and color) that does line-wrapping. This view expects that its associated element has child elements that represent the lines it should be wrapping. It is implemented as a vertical box that contains logical line views. The logical line views are nested classes that render the logical line as multiple physical line if the logical line is too wide to fit within the allocation. The line views draw upon the outer class for its state to reduce their memory requirements.

The line views do all of their rendering through the `drawLine` method which in turn does all of its rendering through the `drawSelectedText` and `drawUnselectedText` methods. This enables subclasses to easily specialize the rendering without concern for the layout aspects.

See Also:
  - `View`

## Field Summary

### Fields declared in class View

`BadBreakWeight, ExcellentBreakWeight, ForcedBreakWeight, GoodBreakWeight, X_AXIS, Y_AXIS`
Modifier and Type
Field
Description
`static final int`
`BadBreakWeight`
The weight to indicate a view is a bad break opportunity for the purpose of formatting.
`static final int`
`ExcellentBreakWeight`
The weight to indicate a view supports breaking, and this represents a very attractive place to break.
`static final int`
`ForcedBreakWeight`
The weight to indicate a view supports breaking, and must be broken to be represented properly when placed in a view that formats its children by breaking them.
`static final int`
`GoodBreakWeight`
The weight to indicate a view supports breaking, but better opportunities probably exist.
`static final int`
`X_AXIS`
Axis for format/break operations.
`static final int`
`Y_AXIS`
Axis for format/break operations.

### Fields declared in interface SwingConstants

`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`
Modifier and Type
Field
Description
`static final int`
`BOTTOM`
Box-orientation constant used to specify the bottom of a box.
`static final int`
`CENTER`
The central position in an area.
`static final int`
`EAST`
Compass-direction east (right).
`static final int`
`HORIZONTAL`
Horizontal orientation.
`static final int`
`LEADING`
Identifies the leading edge of text for use with left-to-right and right-to-left languages.
`static final int`
`LEFT`
Box-orientation constant used to specify the left side of a box.
`static final int`
`NEXT`
Identifies the next direction in a sequence.
`static final int`
`NORTH`
Compass-direction North (up).
`static final int`
`NORTH_EAST`
Compass-direction north-east (upper right).
`static final int`
`NORTH_WEST`
Compass-direction north west (upper left).
`static final int`
`PREVIOUS`
Identifies the previous direction in a sequence.
`static final int`
`RIGHT`
Box-orientation constant used to specify the right side of a box.
`static final int`
`SOUTH`
Compass-direction south (down).
`static final int`
`SOUTH_EAST`
Compass-direction south-east (lower right).
`static final int`
`SOUTH_WEST`
Compass-direction south-west (lower left).
`static final int`
`TOP`
Box-orientation constant used to specify the top of a box.
`static final int`
`TRAILING`
Identifies the trailing edge of text for use with left-to-right and right-to-left languages.
`static final int`
`VERTICAL`
Vertical orientation.
`static final int`
`WEST`
Compass-direction west (left).

## Constructor Summary

Constructors
Constructor
Description
`WrappedPlainView(Element elem)`
Creates a new WrappedPlainView.
`WrappedPlainView(Element elem, boolean wordWrap)`
Creates a new WrappedPlainView.

## Method Summary

Modifier and Type
Method
Description
`protected int`
`calculateBreakPosition(int p0, int p1)`
This is called by the nested wrapped line views to determine the break location.
`void`
`changedUpdate(DocumentEvent e, Shape a, ViewFactory f)`
Gives notification from the document that attributes were changed in a location that this view is responsible for.
`protected void`
`drawLine(int p0, int p1, Graphics2D g, float x, float y)`
Renders a line of text, suppressing whitespace at the end and expanding any tabs.
`protected void`
`drawLine(int p0, int p1, Graphics g, int x, int y)`
Deprecated.
replaced by `drawLine(int, int, Graphics2D, float, float)`
`protected float`
`drawSelectedText(Graphics2D g, float x, float y, int p0, int p1)`
Renders the given range in the model as selected text.
`protected int`
`drawSelectedText(Graphics g, int x, int y, int p0, int p1)`
Deprecated.
replaced by `drawSelectedText(Graphics2D, float, float, int, int)`
`protected float`
`drawUnselectedText(Graphics2D g, float x, float y, int p0, int p1)`
Renders the given range in the model as normal unselected text.
`protected int`
`drawUnselectedText(Graphics g, int x, int y, int p0, int p1)`
Deprecated.
replaced by `drawUnselectedText(Graphics2D, float, float, int, int)`
`protected final Segment`
`getLineBuffer()`
Gives access to a buffer that can be used to fetch text from the associated document.
`float`
`getMaximumSpan(int axis)`
Determines the maximum span for this view along an axis.
`float`
`getMinimumSpan(int axis)`
Determines the minimum span for this view along an axis.
`float`
`getPreferredSpan(int axis)`
Determines the preferred span for this view along an axis.
`protected int`
`getTabSize()`
Returns the tab size set for the document, defaulting to 8.
`void`
`insertUpdate(DocumentEvent e, Shape a, ViewFactory f)`
Gives notification that something was inserted into the document in a location that this view is responsible for.
`protected void`
`loadChildren(ViewFactory f)`
Loads all of the children to initialize the view.
`float`
`nextTabStop(float x, int tabOffset)`
Returns the next tab stop position after a given reference position.
`void`
`paint(Graphics g, Shape a)`
Renders using the given rendering surface and area on that surface.
`void`
`removeUpdate(DocumentEvent e, Shape a, ViewFactory f)`
Gives notification that something was removed from the document in a location that this view is responsible for.
`void`
`setSize(float width, float height)`
Sets the size of the view.

### Methods declared in class BoxView

`baselineLayout, baselineRequirements, calculateMajorAxisRequirements, calculateMinorAxisRequirements, childAllocation, flipEastAndWestAtEnds, forwardUpdate, getAlignment, getAxis, getChildAllocation, getHeight, getOffset, getResizeWeight, getSpan, getViewAtPoint, getWidth, isAfter, isAllocationValid, isBefore, isLayoutValid, layout, layoutChanged, layoutMajorAxis, layoutMinorAxis, modelToView, paintChild, preferenceChanged, replace, setAxis, viewToModel`
Modifier and Type
Method
Description
`protected void`
`baselineLayout(int targetSpan, int axis, int[] offsets, int[] spans)`
Computes the location and extent of each child view in this `BoxView` given the `targetSpan`, which is the width (or height) of the region we have to work with.
`protected SizeRequirements`
`baselineRequirements(int axis, SizeRequirements r)`
Calculates the size requirements for this `BoxView` by examining the size of each child view.
`protected SizeRequirements`
`calculateMajorAxisRequirements(int axis, SizeRequirements r)`
Calculates the size requirements for the major axis `axis`.
`protected SizeRequirements`
`calculateMinorAxisRequirements(int axis, SizeRequirements r)`
Calculates the size requirements for the minor axis `axis`.
`protected void`
`childAllocation(int index, Rectangle alloc)`
Allocates a region for a child view.
`protected boolean`
`flipEastAndWestAtEnds(int position, Position.Bias bias)`
Determines in which direction the next view lays.
`protected void`
`forwardUpdate(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a, ViewFactory f)`
Forwards the given `DocumentEvent` to the child views that need to be notified of the change to the model.
`float`
`getAlignment(int axis)`
Determines the desired alignment for this view along an axis.
`int`
`getAxis()`
Fetches the tile axis property.
`Shape`
`getChildAllocation(int index, Shape a)`
Fetches the allocation for the given child view.
`int`
`getHeight()`
Returns the current height of the box.
`protected int`
`getOffset(int axis, int childIndex)`
Fetches the offset of a particular child's current layout.
`int`
`getResizeWeight(int axis)`
Gets the resize weight.
`protected int`
`getSpan(int axis, int childIndex)`
Fetches the span of a particular child's current layout.
`protected View`
`getViewAtPoint(int x, int y, Rectangle alloc)`
Fetches the child view at the given coordinates.
`int`
`getWidth()`
Returns the current width of the box.
`protected boolean`
`isAfter(int x, int y, Rectangle innerAlloc)`
Determines if a point falls after an allocated region.
`protected boolean`
`isAllocationValid()`
Are the allocations for the children still valid?
`protected boolean`
`isBefore(int x, int y, Rectangle innerAlloc)`
Determines if a point falls before an allocated region.
`protected boolean`
`isLayoutValid(int axis)`
Determines if the layout is valid along the given axis.
`protected void`
`layout(int width, int height)`
Perform layout on the box
`void`
`layoutChanged(int axis)`
Invalidates the layout along an axis.
`protected void`
`layoutMajorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
Performs layout for the major axis of the box (i.e. the axis that it represents).
`protected void`
`layoutMinorAxis(int targetSpan, int axis, int[] offsets, int[] spans)`
Performs layout for the minor axis of the box (i.e. the axis orthogonal to the axis that it represents).
`Shape`
`modelToView(int pos, Shape a, Position.Bias b)`
Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`protected void`
`paintChild(Graphics g, Rectangle alloc, int index)`
Paints a child.
`void`
`preferenceChanged(View child, boolean width, boolean height)`
This is called by a child to indicate its preferred span has changed.
`void`
`replace(int index, int length, View[] elems)`
Invalidates the layout and resizes the cache of requests/allocations.
`void`
`setAxis(int axis)`
Sets the tile axis property.
`int`
`viewToModel(float x, float y, Shape a, Position.Bias[] bias)`
Provides a mapping from the view coordinate space to the logical coordinate space of the model.

### Methods declared in class CompositeView

`getBottomInset, getInsideAllocation, getLeftInset, getNextEastWestVisualPositionFrom, getNextNorthSouthVisualPositionFrom, getNextVisualPositionFrom, getRightInset, getTopInset, getView, getViewAtPosition, getViewCount, getViewIndex, getViewIndexAtPosition, modelToView, setInsets, setParagraphInsets, setParent`
Modifier and Type
Method
Description
`protected short`
`getBottomInset()`
Gets the bottom inset.
`protected Rectangle`
`getInsideAllocation(Shape a)`
Translates the immutable allocation given to the view to a mutable allocation that represents the interior allocation (i.e. the bounds of the given allocation with the top, left, bottom, and right insets removed.
`protected short`
`getLeftInset()`
Gets the left inset.
`protected int`
`getNextEastWestVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
Returns the next visual position for the cursor, in either the east or west direction.
`protected int`
`getNextNorthSouthVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
Returns the next visual position for the cursor, in either the north or south direction.
`int`
`getNextVisualPositionFrom(int pos, Position.Bias b, Shape a, int direction, Position.Bias[] biasRet)`
Provides a way to determine the next visually represented model location that one might place a caret.
`protected short`
`getRightInset()`
Gets the right inset.
`protected short`
`getTopInset()`
Gets the top inset.
`View`
`getView(int n)`
Returns the n-th view in this container.
`protected View`
`getViewAtPosition(int pos, Rectangle a)`
Fetches the child view that represents the given position in the model.
`int`
`getViewCount()`
Returns the number of child views of this view.
`int`
`getViewIndex(int pos, Position.Bias b)`
Returns the child view index representing the given position in the model.
`protected int`
`getViewIndexAtPosition(int pos)`
Fetches the child view index representing the given position in the model.
`Shape`
`modelToView(int p0, Position.Bias b0, int p1, Position.Bias b1, Shape a)`
Provides a mapping from the document model coordinate space to the coordinate space of the view mapped to it.
`protected void`
`setInsets(short top, short left, short bottom, short right)`
Sets the insets for the view.
`protected void`
`setParagraphInsets(AttributeSet attr)`
Sets the insets from the paragraph attributes specified in the given attributes.
`void`
`setParent(View parent)`
Sets the parent of the view.

### Methods declared in class View

`append, breakView, createFragment, forwardUpdateToView, getAttributes, getBreakWeight, getContainer, getDocument, getElement, getEndOffset, getGraphics, getParent, getStartOffset, getToolTipText, getViewFactory, getViewIndex, insert, isVisible, modelToView, remove, removeAll, updateChildren, updateLayout, viewToModel`
Modifier and Type
Method
Description
`void`
`append(View v)`
Appends a single child view.
`View`
`breakView(int axis, int offset, float pos, float len)`
Tries to break this view on the given axis.
`View`
`createFragment(int p0, int p1)`
Creates a view that represents a portion of the element.
`protected void`
`forwardUpdateToView(View v, DocumentEvent e, Shape a, ViewFactory f)`
Forwards the `DocumentEvent` to the give child view.
`AttributeSet`
`getAttributes()`
Fetches the attributes to use when rendering.
`int`
`getBreakWeight(int axis, float pos, float len)`
Determines how attractive a break opportunity in this view is.
`Container`
`getContainer()`
Fetches the container hosting the view.
`Document`
`getDocument()`
Fetches the model associated with the view.
`Element`
`getElement()`
Fetches the structural portion of the subject that this view is mapped to.
`int`
`getEndOffset()`
Fetches the portion of the model for which this view is responsible.
`Graphics`
`getGraphics()`
Fetch a `Graphics` for rendering.
`View`
`getParent()`
Returns the parent of the view.
`int`
`getStartOffset()`
Fetches the portion of the model for which this view is responsible.
`String`
`getToolTipText(float x, float y, Shape allocation)`
Returns the tooltip text at the specified location.
`ViewFactory`
`getViewFactory()`
Fetches the `ViewFactory` implementation that is feeding the view hierarchy.
`int`
`getViewIndex(float x, float y, Shape allocation)`
Returns the child view index representing the given position in the view.
`void`
`insert(int offs, View v)`
Inserts a single child view.
`boolean`
`isVisible()`
Returns a boolean that indicates whether the view is visible or not.
`Shape`
`modelToView(int pos, Shape a)`
Deprecated.
`void`
`remove(int i)`
Removes one of the children at the given position.
`void`
`removeAll()`
Removes all of the children.
`protected boolean`
`updateChildren(DocumentEvent.ElementChange ec, DocumentEvent e, ViewFactory f)`
Updates the child views in response to receiving notification that the model changed, and there is change record for the element this view is responsible for.
`protected void`
`updateLayout(DocumentEvent.ElementChange ec, DocumentEvent e, Shape a)`
Updates the layout in response to receiving notification of change from the model.
`int`
`viewToModel(float x, float y, Shape a)`
Deprecated.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### WrappedPlainView

public WrappedPlainView(Element elem)
Creates a new WrappedPlainView. Lines will be wrapped on character boundaries.

Parameters:
  `elem` - the element underlying the view

### WrappedPlainView

public WrappedPlainView(Element elem, boolean wordWrap)
Creates a new WrappedPlainView. Lines can be wrapped on either character or word boundaries depending upon the setting of the wordWrap parameter.

Parameters:
  `elem` - the element underlying the view
  `wordWrap` - should lines be wrapped on word boundaries?

## Method Details

### getTabSize

protected int getTabSize()
Returns the tab size set for the document, defaulting to 8.

Returns:
  the tab size

### drawLine

@Deprecated(since="9") protected void drawLine(int p0, int p1, Graphics g, int x, int y)
Deprecated.
replaced by `drawLine(int, int, Graphics2D, float, float)`
Renders a line of text, suppressing whitespace at the end and expanding any tabs. This is implemented to make calls to the methods `drawUnselectedText` and `drawSelectedText` so that the way selected and unselected text are rendered can be customized.

Parameters:
  `p0` - the starting document location to use >= 0
  `p1` - the ending document location to use >= p1
  `g` - the graphics context
  `x` - the starting X position >= 0
  `y` - the starting Y position >= 0
See Also:
  - `drawUnselectedText(Graphics, int, int, int, int)`
  - `drawSelectedText(Graphics, int, int, int, int)`

### drawLine

protected void drawLine(int p0, int p1, Graphics2D g, float x, float y)
Renders a line of text, suppressing whitespace at the end and expanding any tabs. This is implemented to make calls to the methods `drawUnselectedText` and `drawSelectedText` so that the way selected and unselected text are rendered can be customized.

Parameters:
  `p0` - the starting document location to use >= 0
  `p1` - the ending document location to use >= p1
  `g` - the graphics context
  `x` - the starting X position >= 0
  `y` - the starting Y position >= 0
Since:
  9
See Also:
  - `drawUnselectedText(Graphics, int, int, int, int)`
  - `drawSelectedText(Graphics, int, int, int, int)`

### drawUnselectedText

@Deprecated(since="9") protected int drawUnselectedText(Graphics g, int x, int y, int p0, int p1) throws BadLocationException
Deprecated.
replaced by `drawUnselectedText(Graphics2D, float, float, int, int)`
Renders the given range in the model as normal unselected text.

Parameters:
  `g` - the graphics context
  `x` - the starting X coordinate >= 0
  `y` - the starting Y coordinate >= 0
  `p0` - the beginning position in the model >= 0
  `p1` - the ending position in the model >= p0
Returns:
  the X location of the end of the range >= 0
Throws:
  `BadLocationException` - if the range is invalid

### drawUnselectedText

protected float drawUnselectedText(Graphics2D g, float x, float y, int p0, int p1) throws BadLocationException
Renders the given range in the model as normal unselected text.

Parameters:
  `g` - the graphics context
  `x` - the starting X coordinate >= 0
  `y` - the starting Y coordinate >= 0
  `p0` - the beginning position in the model >= 0
  `p1` - the ending position in the model >= p0
Returns:
  the X location of the end of the range >= 0
Throws:
  `BadLocationException` - if the range is invalid
Since:
  9

### drawSelectedText

@Deprecated(since="9") protected int drawSelectedText(Graphics g, int x, int y, int p0, int p1) throws BadLocationException
Deprecated.
replaced by `drawSelectedText(Graphics2D, float, float, int, int)`
Renders the given range in the model as selected text. This is implemented to render the text in the color specified in the hosting component. It assumes the highlighter will render the selected background.

Parameters:
  `g` - the graphics context
  `x` - the starting X coordinate >= 0
  `y` - the starting Y coordinate >= 0
  `p0` - the beginning position in the model >= 0
  `p1` - the ending position in the model >= p0
Returns:
  the location of the end of the range.
Throws:
  `BadLocationException` - if the range is invalid

### drawSelectedText

protected float drawSelectedText(Graphics2D g, float x, float y, int p0, int p1) throws BadLocationException
Renders the given range in the model as selected text. This is implemented to render the text in the color specified in the hosting component. It assumes the highlighter will render the selected background.

Parameters:
  `g` - the graphics context
  `x` - the starting X coordinate >= 0
  `y` - the starting Y coordinate >= 0
  `p0` - the beginning position in the model >= 0
  `p1` - the ending position in the model >= p0
Returns:
  the location of the end of the range.
Throws:
  `BadLocationException` - if the range is invalid
Since:
  9

### getLineBuffer

protected final Segment getLineBuffer()
Gives access to a buffer that can be used to fetch text from the associated document.

Returns:
  the buffer

### calculateBreakPosition

protected int calculateBreakPosition(int p0, int p1)
This is called by the nested wrapped line views to determine the break location. This can be reimplemented to alter the breaking behavior. It will either break at word or character boundaries depending upon the break argument given at construction.

Parameters:
  `p0` - the starting document location
  `p1` - the ending document location to use
Returns:
  the break position

### loadChildren

protected void loadChildren(ViewFactory f)
Loads all of the children to initialize the view. This is called by the `setParent` method. Subclasses can reimplement this to initialize their child views in a different manner. The default implementation creates a child view for each child element.

Overrides:
  `loadChildren` in class `CompositeView`
Parameters:
  `f` - the view factory
See Also:
  - `CompositeView.setParent(View)`

### nextTabStop

public float nextTabStop(float x, int tabOffset)
Returns the next tab stop position after a given reference position. This implementation does not support things like centering so it ignores the tabOffset argument.

Specified by:
  `nextTabStop` in interface `TabExpander`
Parameters:
  `x` - the current position >= 0
  `tabOffset` - the position within the text stream that the tab occurred at >= 0.
Returns:
  the tab stop, measured in points >= 0

### paint

public void paint(Graphics g, Shape a)
Renders using the given rendering surface and area on that surface. This is implemented to stash the selection positions, selection colors, and font metrics for the nested lines to use.

Overrides:
  `paint` in class `BoxView`
Parameters:
  `g` - the rendering surface to use
  `a` - the allocated region to render into
See Also:
  - `View.paint(Graphics, Shape)`

### setSize

public void setSize(float width, float height)
Sets the size of the view. This should cause layout of the view along the given axis, if it has any layout duties.

Overrides:
  `setSize` in class `BoxView`
Parameters:
  `width` - the width >= 0
  `height` - the height >= 0

### getPreferredSpan

public float getPreferredSpan(int axis)
Determines the preferred span for this view along an axis. This is implemented to provide the superclass behavior after first making sure that the current font metrics are cached (for the nested lines which use the metrics to determine the height of the potentially wrapped lines).

Overrides:
  `getPreferredSpan` in class `BoxView`
Parameters:
  `axis` - may be either View.X_AXIS or View.Y_AXIS
Returns:
  the span the view would like to be rendered into. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
See Also:
  - `View.getPreferredSpan(int)`

### getMinimumSpan

public float getMinimumSpan(int axis)
Determines the minimum span for this view along an axis. This is implemented to provide the superclass behavior after first making sure that the current font metrics are cached (for the nested lines which use the metrics to determine the height of the potentially wrapped lines).

Overrides:
  `getMinimumSpan` in class `BoxView`
Parameters:
  `axis` - may be either View.X_AXIS or View.Y_AXIS
Returns:
  the span the view would like to be rendered into. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
See Also:
  - `View.getMinimumSpan(int)`

### getMaximumSpan

public float getMaximumSpan(int axis)
Determines the maximum span for this view along an axis. This is implemented to provide the superclass behavior after first making sure that the current font metrics are cached (for the nested lines which use the metrics to determine the height of the potentially wrapped lines).

Overrides:
  `getMaximumSpan` in class `BoxView`
Parameters:
  `axis` - may be either View.X_AXIS or View.Y_AXIS
Returns:
  the span the view would like to be rendered into. Typically the view is told to render into the span that is returned, although there is no guarantee. The parent may choose to resize or break the view.
See Also:
  - `View.getMaximumSpan(int)`

### insertUpdate

public void insertUpdate(DocumentEvent e, Shape a, ViewFactory f)
Gives notification that something was inserted into the document in a location that this view is responsible for. This is implemented to simply update the children.

Overrides:
  `insertUpdate` in class `View`
Parameters:
  `e` - the change information from the associated document
  `a` - the current allocation of the view
  `f` - the factory to use to rebuild if the view has children
See Also:
  - `View.insertUpdate(DocumentEvent, Shape, ViewFactory)`

### removeUpdate

public void removeUpdate(DocumentEvent e, Shape a, ViewFactory f)
Gives notification that something was removed from the document in a location that this view is responsible for. This is implemented to simply update the children.

Overrides:
  `removeUpdate` in class `View`
Parameters:
  `e` - the change information from the associated document
  `a` - the current allocation of the view
  `f` - the factory to use to rebuild if the view has children
See Also:
  - `View.removeUpdate(DocumentEvent, Shape, ViewFactory)`

### changedUpdate

public void changedUpdate(DocumentEvent e, Shape a, ViewFactory f)
Gives notification from the document that attributes were changed in a location that this view is responsible for.

Overrides:
  `changedUpdate` in class `View`
Parameters:
  `e` - the change information from the associated document
  `a` - the current allocation of the view
  `f` - the factory to use to rebuild if the view has children
See Also:
  - `View.changedUpdate(DocumentEvent, Shape, ViewFactory)`